/**
 * 
 */
package be.spacebel.ssa.swe.beans;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import org.richfaces.component.SortOrder;

import be.spacebel.ssa.swe.ui.UIFilter;

/**
 * @author cnl
 * 
 */
public class UISearchBean {
	private be.spacebel.ssa.swe.beans.MetadataBean metadataBean;
	private UIFilter filter = new UIFilter();

	private List<String> selectedOfferings = new ArrayList<String>();
	private be.spacebel.ssa.swe.beans.SearchBean searchBean;
	private SortOrder offeringOrder = SortOrder.unsorted;
	private String clickedOffering = null;
	private be.spacebel.ssa.swe.beans.RefineTreeBean refineTreeBean;

	
	
	public String getClickedOffering() {
		return clickedOffering;
	}

	public void selectAll() {
		ArrayList<String> selectedProps = getSelectedProps();
		ArrayList<String> mOffering = new ArrayList<String>(
				searchBean.getMatchingOfferingNames());
		setSelectedOfferings(mOffering);
		getRefineTreeBean().addAll(mOffering, selectedProps);

	}

	public void unselectAll() {
		getSelectedOfferings().clear();
		getRefineTreeBean().removeAll();
	}

	public void reset() {
		setFilter(new UIFilter());
		unselectAll();
		update();
	}

	public boolean isSelected(String offering) {
		return this.selectedOfferings.contains(offering);
	}

	public void setClickedOffering(String clickedOffering) {
		this.clickedOffering = clickedOffering;
	}

	public SortOrder getOfferingOrder() {
		return offeringOrder;
	}

	public void setOfferingOrder(SortOrder offeringOrder) {
		this.offeringOrder = offeringOrder;
	}

	public UIFilter getFilter() {
		return filter;
	}

	public void sortByOffering() {
		if (offeringOrder.equals(SortOrder.ascending)) {
			offeringOrder = SortOrder.descending;
		} else {
			offeringOrder = SortOrder.ascending;
		}
	}

	private ArrayList<String> getSelectedProps() {
		if(getFilter().getProperties()== null) {
			return new ArrayList<String>();
		}
		else {
			return new ArrayList<String>(Arrays.asList(getFilter().getProperties()));
		}
		
	}
	
	
	public void clickOffering() {
		ArrayList<String> selectedProps = getSelectedProps();

		if (getSelectedOfferings().contains(this.clickedOffering)) {
			getSelectedOfferings().remove(this.clickedOffering);
			getRefineTreeBean().remove(this.clickedOffering);

		} else {
			getSelectedOfferings().add(this.clickedOffering);
			getRefineTreeBean().add(this.clickedOffering,selectedProps);
		}

		return;
	}

	public void setFilter(UIFilter filter) {
		this.filter = filter;
	}

	public void update() {
		searchBean.update(filter);
	}

	public List<String> getSelectedOfferings() {
		return this.selectedOfferings;
	}

	public void setSelectedOfferings(List<String> selectedOfferings) {
		this.selectedOfferings = selectedOfferings;
	}

	public UISearchBean() {
	}

	public be.spacebel.ssa.swe.beans.MetadataBean getMetadataBean() {
		return metadataBean;
	}

	public void setMetadataBean(
			be.spacebel.ssa.swe.beans.MetadataBean metadataBean) {
		this.metadataBean = metadataBean;
	}

	public be.spacebel.ssa.swe.beans.SearchBean getSearchBean() {
		return searchBean;
	}

	public void setSearchBean(be.spacebel.ssa.swe.beans.SearchBean searchBean) {
		this.searchBean = searchBean;
	}

	public be.spacebel.ssa.swe.beans.RefineTreeBean getRefineTreeBean() {
		return refineTreeBean;
	}

	public void setRefineTreeBean(
			be.spacebel.ssa.swe.beans.RefineTreeBean refineTreeBean) {
		this.refineTreeBean = refineTreeBean;
	}
}
