package be.spacebel.ssa.swe.data;

import swe.ssa.esa.swep.datamodel.common.MetadataType.ContentDescription.Field;
import swe.ssa.esa.swep.datamodel.common.MetadataType.ContentDescription.Field.ObservableProperty;

public class FieldMetadata {

	private String identifier;
	private String name;
	private String description;
	private String uom;
	private String dataType;
	private String dataCategory;
	private String observableProperty;

	public FieldMetadata(Field field) {
		identifier = field.getIdentifier();
		name = field.getName();
		description = field.getDescription();
		uom = field.getUom();
		dataType = field.getDataType().toString();
		dataCategory = field.getDataCategory().toString();
		observableProperty = null;
		
		if(field.getObservablePropertyArray().length > 0 && field.getObservablePropertyArray(0) != null) {
		observableProperty = field.getObservablePropertyArray(0).getIdentifier().getStringValue();
		}
		
	
	}

	public String getIdentifier() {
		return identifier;
	}

	public void setIdentifier(String identifier) {
		this.identifier = identifier;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public String getUom() {
		return uom;
	}

	public void setUom(String uom) {
		this.uom = uom;
	}

	public String getDataType() {
		return dataType;
	}

	public void setDataType(String dataType) {
		this.dataType = dataType;
	}

	public String getDataCategory() {
		return dataCategory;
	}

	public void setDataCategory(String dataCategory) {
		this.dataCategory = dataCategory;
	}

	public String getObservableProperty() {
		return observableProperty;
	}

	public void setObservableProperty(String observableProperty) {
		this.observableProperty = observableProperty;
	}
}
