package be.spacebel.ssa.swe.data;

import java.util.Collection;

import javax.swing.tree.TreeNode;

import be.spacebel.ssa.swe.util.TreeNodeImpl;



/**
 * TreeNodeImpl from Richfaces cannot be used because of a class loading problem (probably)
 * But the issue couldn't be fixed (treenode cannot be cast to spring.treenode)
 * Therefore we created a TreeNodeImpl which implements TreeNode from spring
 * @author cnl
 *
 */

public class SelectableNode extends TreeNodeImpl {

	
	/**
	 * Extension of a default TreeNode: this node has a name, and can be selectable
	 * Type give indication on the node type (offering, property or field)
	 */
    protected String type;
    protected String name;
    protected boolean selected=false;
    protected boolean expanded=true;
 
    public SelectableNode(String type, String name) {
    	super();
    	setType(type);
    	setName(name);
    	System.out.println("new Selectable Node");
    	
    }
    
    
    
    public boolean isExpanded() {
        return expanded;
    }
 
    public void setExpanded(boolean expanded) {
        this.expanded = expanded;
    }
     
    public boolean isSelected() {
		return selected;
	}

	public void setSelected(boolean selected) {
		System.out.println(getName()+ " is now "+selected);
		this.selected = selected;
		if(getChildCount()>0) {
			System.out.println("has children");
			for(TreeNode node : this.getChildrenMap().values() ) {
				SelectableNode selectableNode = (SelectableNode) node;
				selectableNode.setSelected(selected);
			}
		}
		
	}

	public String getName() {
        return name;
    }
 
    public void setName(String name) {
        this.name = name;
        System.out.println(name);
    	
    }
 
    public String getType() {
        return type;
    }
 
    public void setType(String type) {
        this.type = type;
    }
 
    @Override
    public String toString() {
        return this.name;
    }
}