package be.spacebel.ssa.swe.readers;

import java.io.IOException;
import java.net.URL;
import java.util.HashMap;
import java.util.Map;

import org.apache.xmlbeans.XmlException;

import swe.ssa.esa.swep.datamodel.userDataAccessService.GetCapabilitiesResponseMessageDocument;

import be.spacebel.ssa.swe.clients.ClientHandler;
import be.spacebel.ssa.swe.clients.DataAccessClient;
import be.spacebel.ssa.swe.data.OfferingMetadata;

import net.opengis.swes.x20.AbstractContentsType.Offering;

public class MetadataReader {

	private DataAccessClient dataAccessClient = null;
	public MetadataReader() throws Exception {
		dataAccessClient = ClientHandler.getDataAccessClient();
	}
	
	public  Map<String, OfferingMetadata> getOfferingDescriptions() throws Exception {
		// request getCapabilities operation on UserDataAccess service
		// temporary commented
		//GetCapabilitiesResponseMessageDocument getCapabilitiesResponse = dataAccessClient.getCapabilities();
		// dummy
		GetCapabilitiesResponseMessageDocument getCapabilitiesResponse = readDummyCapabilities();
		Offering[] offeringArray = getCapabilitiesResponse.getGetCapabilitiesResponseMessage().getContents().getOfferingArray();
		// Build map
		HashMap<String,OfferingMetadata> map = new HashMap<String,OfferingMetadata>();
		for(Offering offering : offeringArray) {
			String identifier = offering.getAbstractOffering().getIdentifier();
			
			map.put(identifier, new OfferingMetadata(offering));
		}
		return map;
	}

	private  GetCapabilitiesResponseMessageDocument readDummyCapabilities() throws XmlException, IOException {
		URL capabilitiesURL = this.getClass().getClassLoader()
				.getResource("UserDataAccessCapabilities.xml");
		GetCapabilitiesResponseMessageDocument cap = GetCapabilitiesResponseMessageDocument.Factory.parse(capabilitiesURL);
		return cap;
	}

}
