package be.spacebel.ssa.swe.util;

import java.util.ArrayList;
import java.util.Arrays;

import be.spacebel.ssa.swe.data.OfferingMetadata;
import be.spacebel.ssa.swe.ui.UIFilter;

public class FilterUtil {

	public static boolean match(OfferingMetadata offering, UIFilter filter) {
		boolean match = true;
		if (filter.getAcquisition() != null) {
			if (!offering.getAcquisition().equals(filter.getAcquisition())) {
				return false;
			}
		}

		if (filter.getDomain() != null) {
			if (!offering.getDomain().equals(filter.getDomain())) {
				return false;
			}
		}

		if (filter.getUserDomain() != null) {
			if (!offering.getUserDomain().equals(filter.getUserDomain())) {
				return false;
			}
		}
		if (filter.getProvider() != null) {
			if (!offering.getProvider().getName().equals(filter.getProvider())) {
				return false;
			}
		}
		if (filter.getProperties() != null) {
			for (String prop : filter.getProperties()) {

				ArrayList<String> offprops = new ArrayList<String>(
						Arrays.asList(offering.getObservablePropertyArray()));
				if (!offprops.contains(prop)) {
					return false;
				}
			}
		}

		return match;

	}
}
