package be.spacebel.ssa.swe.util;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Map;

import javax.swing.tree.TreeNode;

public class TreeNodeImpl implements TreeNode {

	protected Map<Object, TreeNode> childrenMap;

	protected TreeNode parent;

	public TreeNodeImpl() {
		this.childrenMap = new HashMap<Object, TreeNode>();
	}

	@Override
	public Enumeration<TreeNode> children() {
		return Collections.enumeration(this.childrenMap.values());
	}

	@Override
	public boolean getAllowsChildren() {
		// TODO Auto-generated method stub
		return true;
	}

	@Override
	public TreeNode getChildAt(int arg0) {
		return this.childrenMap.get(arg0);
	}

	@Override
	public int getChildCount() {
		return this.childrenMap.size();
	}

	@Override
	public int getIndex(TreeNode arg0) {
		return (new ArrayList<TreeNode>(this.childrenMap.values())).indexOf(arg0);
	}

	@Override
	public TreeNode getParent() {
		return this.parent;
	}

	public void setParent(TreeNode parent) {
		this.parent = parent;
		return;
	}

	public void addChild(Object identifier, TreeNodeImpl child) {
		this.childrenMap.put(identifier, child);
		child.setParent(this);
	}
	
	/**
	 * remove
	 public void addChildCond(Object identifier, TreeNodeImpl child) {
		if(!this.childrenMap.containsKey(identifier)) {
			addChild(identifier, child);
		}
		
	}
*/
	
	public Map<Object, TreeNode> getChildrenMap() {
		return childrenMap;
	}

	public void setChildrenMap(Map<Object, TreeNode> children) {
		this.childrenMap = children;
	}

	@Override
	public boolean isLeaf() {
		// TODO Auto-generated method stub
		return (this.childrenMap.size() == 0);
	}

}
