package be.spacebel.test.util;

/** 
 * Christophe Noel 2012 - Typical Resource Bundle Handler
 */
import java.util.PropertyResourceBundle;
import java.util.ResourceBundle;

public class BundleUtil {

	// This means the config.property file in the src directory.
	private final static String propertiesFile = "be.spacebel.resources.config";
	private static ResourceBundle bundle = PropertyResourceBundle
			.getBundle(propertiesFile);

	private BundleUtil() {
	}

	// This is a generic method to get the property
	public static String get(String name) {
		return bundle.getString(name);
	}

	// This is preferably the way you should get the property.
	// Link between a property and a specify name is all contained in the
	// present class.
	public static String getProperty() {
		return bundle.getString("xxx.property");
	}
}
	