package be.spacebel.test.util;

import java.io.PrintWriter;
import java.io.StringWriter;

import org.apache.log4j.Logger;

/**
 * Generic exception thrown when we need to display an error on the client side.
 * 
 * @author jpr
 * 
 */
public class PortalDisplayException extends Exception {

	private static final long serialVersionUID = 1L;

	private final Logger log = Logger.getLogger(getClass());

	private String message;

	public PortalDisplayException(Throwable throwable) {
		if (throwable.getCause() != null) {
			throwable = throwable.getCause();
		}
		log.error(getStackTraceAsString(throwable, false));
		this.message = throwable.getMessage();
	}

	public PortalDisplayException(String message) {
		log.error(message);
		this.message = message;
	}

	public String getMessage() {
		return message;
	}

	public void setMessage(String message) {
		this.message = message;
	}

	public static String getStackTraceAsString(Throwable t, boolean html) {
		StringWriter sw = new StringWriter();
		t.printStackTrace(new PrintWriter(sw));
		String result = sw.toString();
		if (html) {
			result = result.replaceAll("\n", "<br/>");
		}
		return result;
	}

}
